const pagesRoot='/pages'
export const navigateTo =(url,query)=>{
    uni.navigateTo({
        url:pagesRoot+url+getQueryString(query),
    })
}

export const redirectTo=(url,query)=>{
    uni.redirectTo({
        url:pagesRoot+url+getQueryString(query),
    })
}

export const switchTab=(url,query)=>{
    uni.switchTab({
        url:pagesRoot+url+getQueryString(query),
    })
}

export const reLaunch=(url,query)=>{
    uni.reLaunch({
        url:pagesRoot+url+getQueryString(query),
    })
}

const getQueryString=(query)=>{
    let queryString=''
    if(query)
        Object.entries(query).map((e)=>{
            const key=e[0]
            const value=e[1]
            if(value||value===0){
                if(queryString)
                    queryString+=`&${key}=${value}`
                else
                    queryString+=`?${key}=${value}`
            }
        })

    return queryString
}



export const setNavigateBackParams=({reload=false,loadOne=false})=>{
    let pages = getCurrentPages();  //获取所有页面栈实例列表
    if(pages.length===1){
        throw new Error('设置返回页面的data失败，当前页面堆栈中只有一个页面,可能是h5页面刷新了导致的')
    }
    let backPage = pages[ pages.length - 2 ];  //返回页面实例
    backPage.$vm.navigateBackParams = {reload,loadOne};     //修改返回页面的Data，添加navigateBackData值
}
//返回页面参数
export const INIT_BACK_PARAMS={
    reload:false,  //false || true   是否重新加载
    loadOne:false, // false || {id:xxx,index:xxx} 是否重新加载列表中的某一个item。 用于从列表进入编辑页面编辑，再次返回列表后，局部刷新列表，而不是无脑重新加载。
}


